package com.gresham.darwin.server.common;

import java.io.Serializable;

import com.gigaspaces.annotation.pojo.CompoundSpaceIndex;
import com.gigaspaces.annotation.pojo.CompoundSpaceIndexes;
import com.gigaspaces.annotation.pojo.SpaceClass;
import com.gigaspaces.annotation.pojo.SpaceId;
import com.gigaspaces.annotation.pojo.SpaceIndex;
import com.gigaspaces.annotation.pojo.SpaceRouting;
import com.gigaspaces.metadata.index.SpaceIndexType;


@SpaceClass(persist=false)
@CompoundSpaceIndexes({@CompoundSpaceIndex(paths = {"exceptionRecordFqn", "recordKey"})})
public class Entry implements Serializable  {

    private static final long serialVersionUID = 1L;

    private String recFqn;
    private String recordKey;
    private String id;
    private String exceptionRecordFqn;


    public Entry() {
    }

    public Entry(String recordKey, String id, String exceptionRecordFqn, String recFqn) {
        this.recordKey = recordKey;
        this.id = id;
        this.exceptionRecordFqn = exceptionRecordFqn;
        this.recFqn = recFqn;
    }

    @SpaceIndex(type=SpaceIndexType.BASIC)
    public String getRecordKey() {
        return this.recordKey;
    }

    public void setRecordKey(String recordKey) {
        this.recordKey = recordKey;
    }

    @SpaceRouting
    public String getRecFqn() {
        return this.recFqn;
    }

    public void setRecFqn(String recFqn) {
        this.recFqn = recFqn;
    }

    @SpaceId(autoGenerate = false)
    public String getId() {
        return this.id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getExceptionRecordFqn() {
        return this.exceptionRecordFqn;
    }

    public void setExceptionRecordFqn(String exceptionFqn) {
        this.exceptionRecordFqn = exceptionFqn;
    }

}