/**
 * <copyright>
 *
 * Copyright (c) 2010-2011 Gresham Computing plc. All rights reserved.
 *
 * </copyright>
 */
package com.gresham.darwin.server.common;



import org.openspaces.core.GigaSpace;
import org.openspaces.core.GigaSpaceConfigurer;
import org.openspaces.core.space.UrlSpaceConfigurer;
import com.j_spaces.core.IJSpace;

public class EntryTest {

    public static String GS_LICENSE_KEY = "Version=11;Type=PREMIUM;Customer=Gresham_Generic_DEV;Expiration=2017-Apr-18;Add-Ons=MemoryXtend-RocksDB,MemoryXtend-MapDB;Hash=PLRQMNCMntQQVxQZVGxQ";


    /**
     * @param args
     */
    public static void main(String[] args) {
        String spaceUrl = "jini://*/*/data-space?groups=yuval-pc/locators=yuvald-pc";

        UrlSpaceConfigurer spaceConfiguration = new UrlSpaceConfigurer("jini://*/*/" + "data-space")
                .lookupGroups("yuvald-pc")
                .lookupLocators("yuvald-pc");

        spaceConfiguration.addProperty("-Dcom.gs.licensekey", GS_LICENSE_KEY);
        IJSpace jSpace = spaceConfiguration.space();
        GigaSpaceConfigurer gigaSpaceConfigurer = new GigaSpaceConfigurer(jSpace);
        GigaSpace space = gigaSpaceConfigurer.gigaSpace();


        //First we create write two entries in the space. The search attributes are recFqn and exceptionRecordFqn.
        String recFqn = "ctc.MismatchRec";
        Entry entry = new Entry("recordKey1", "id1", "exceptionRecord1",
                recFqn);

        Entry entry2 = new Entry("recordKey2", "id2", "exceptionRecord2",
                recFqn);

        space.write(entry);
        space.write(entry2);

        // We now create a template to do the count
        Entry template = new Entry();
        template.setExceptionRecordFqn("DifferentExceptionRecord");
        template.setRecFqn(recFqn);

        // Ideally the count should be zero because none of the entries have a exceptionRecordFqn of "DifferentExceptionRecord"

        Entry[] entriesArray = space.readMultiple(template);
        int numberOfEntries = entriesArray.length;
        System.out.println("numberOfEntries = " + numberOfEntries);

        int currentCount = space.count(template);
        // But the count is 2
        System.out.println("Count of different entries:" + currentCount);
    }
}